#line 1 "trace.c"
























 


#line 1 "trace.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "trace.h"
#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "trace.h"
#line 1 "ipservice.h"
























 





#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 33 "trace.h"

extern void TraceUDPHeader ( PtrOSFrameRecT   ) ;

extern void TraceFrame ( PtrOSFrameRecT   ) ;

extern void TraceIPHeader ( IPHeaderRecT *   ) ;

extern void TraceETHHeader ( EtherPackedHeaderRecT *   ) ;

extern void TraceMAC ( UCHAR *   ) ;

extern void TraceIP ( ULONG   ) ;

extern void TraceUCHAR ( UCHAR   ) ;

extern void TraceUSHORT ( USHORT   ) ;

extern void TraceUSHORTdec ( USHORT   ) ;

extern void TraceULONG ( ULONG   ) ;

#line 29 "trace.c"
#line 1 "uart0.h"























 




#line 30 "uart0.h"

extern void UART0InitEnvir ( void ) ;

extern void UART0HardwInit( ULONG   ,
                            UCHAR   ,
                            ULONG   ) ;

extern void UART0InputReset ( void ) ;

extern void UART0Send ( UCHAR   ) ;

extern void UART0SendString ( UCHAR *   ) ;

extern ULONG UART0DataPresent ( void ) ;

extern UCHAR UART0GetData ( void ) ;

extern UCHAR UART0Working ( void ) ;



#line 30 "trace.c"
#line 1 "strings.h"
























 




#line 31 "strings.h"


extern void memclear ( void *   ,
                       USHORT   ) ;

extern void memcopy ( void *   ,
                      void *   ,
                      USHORT   ) ;

extern UCHAR Cap ( UCHAR   ) ;

extern void StrCpy ( UCHAR *   ,
               const UCHAR *   ) ;

extern USHORT StrLen ( UCHAR *   ) ;

extern void StrDelete ( UCHAR *   ,
                        USHORT    ,
                        USHORT    ) ;

extern void StrNorm ( UCHAR *   ) ;

extern void StrExp ( USHORT    ,
                     UCHAR *   ) ;

extern void AppendCh ( UCHAR *   ,
                       UCHAR     ) ;

extern void AppendStr ( UCHAR *   ,
                  const UCHAR *   ) ;

extern void Append ( USHORT    ,
                     UCHAR *   ,
               const UCHAR *   ) ;

extern UCHAR * BegOfString ( UCHAR *   ) ;

extern void WordToHexStr ( UCHAR *   ,
                           USHORT    ,
                           UCHAR     ,
                           USHORT    ) ;

extern void WordToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        USHORT    ) ;

extern void LongToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        ULONG     ) ;

extern void LongToHexStr ( UCHAR *   ,
                           USHORT    ,
                           UCHAR     ,
                           ULONG     ) ;

extern void IPToString ( UCHAR *   ,
                         ULONG     ) ;

extern UCHAR Digit ( UCHAR   ) ;

extern UCHAR StrToCard ( UCHAR *    ,
                         USHORT *   ) ;

extern UCHAR StrToLCard ( UCHAR *   ,
                          ULONG *   ) ;

extern UCHAR CompareString ( UCHAR *   ,
                             UCHAR *   ,
                             USHORT    ) ;

extern UCHAR StrToIP ( UCHAR *   ,
                       ULONG *   ) ;

#line 31 "trace.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 32 "trace.c"

static UCHAR Message50 [ ]          = "\r\nNaglowek UDP:" ;
static UCHAR Message51 [ ]          = "\r\nSRCPORT=" ;
static UCHAR Message52 [ ]          = " DSTPORT=" ;
static UCHAR Message53 [ ]          = "\r\nLGTH=" ;
static UCHAR Message54 [ ]          = " UDPSUM=" ;

void TraceUDPHeader ( PtrOSFrameRecT Frame )
{
  USHORT SourcePortNo ;
  USHORT DestinationPortNo ;
  USHORT UDPPackedSize ;
  USHORT UDPCheckSum ;
   
  UART0SendString ( Message50 ) ;
  SourcePortNo = GetUSHORTSwapField ( Frame , 0x22 ) ;
  DestinationPortNo = GetUSHORTSwapField ( Frame , 0x024 ) ;
  UDPPackedSize = GetUSHORTSwapField ( Frame , 0x26 ) ;
  UDPCheckSum = GetUSHORTSwapField ( Frame , 0x28 ) ;
  UART0SendString ( Message51 ) ;
  TraceUSHORTdec ( SourcePortNo ) ;
  UART0SendString ( Message52 ) ;
  TraceUSHORTdec ( DestinationPortNo ) ;
  UART0SendString ( Message53 ) ;
  TraceUSHORTdec ( UDPPackedSize ) ;
  UART0SendString ( Message54 ) ;
  TraceUSHORT ( UDPCheckSum ) ;
  UART0Send ( 0x0D ) ;
  UART0Send ( 0x0A ) ;
}  


static UCHAR TMessage01 [ ]      = "Ramka ETH, DEST=" ;
static UCHAR TMessage02 [ ]      = " SRC=" ;
static UCHAR TMessage03 [ ]      = "\r\nPakiet ARP" ;
static UCHAR TMessage04 [ ]      = "\r\nPakiet IP" ;
static UCHAR TMessage05 [ ]      = "\r\nPakiet ???" ;
static UCHAR TMessage06 [ ]      = "/ICMP" ;
static UCHAR TMessage07 [ ]      = "/TCP" ;
static UCHAR TMessage08 [ ]      = "/UDP" ;
static UCHAR TMessage09 [ ]      = "/???" ;

void TraceFrame ( PtrOSFrameRecT Frame )
{
  EtherPackedHeaderRecT EtherHeader ;
  IPHeaderRecT IPHeader ;
   
  GetEthHeader ( & EtherHeader , Frame ) ;
  UART0SendString ( TMessage01 ) ;
  TraceMAC ( EtherHeader . DestinMACAddress ) ;
  UART0SendString ( TMessage02 ) ;
  TraceMAC ( EtherHeader . SourceMACAddress ) ;
  switch ( EtherHeader . LengthOrType )
  {
    case 0x0806 :
      UART0SendString ( TMessage03 ) ;
      break ;
    case 0x0800 :
      UART0SendString ( TMessage04 ) ;
      SetIPHeaderOrgin ( Frame ) ; 
      GetIPHeader ( & IPHeader , Frame ) ;
      switch ( IPHeader . Protocol )
      {
        case 1                :
          UART0SendString ( TMessage06 ) ;
          break ;
        case 6                 :
          UART0SendString ( TMessage07 ) ;
          break ;
        case 17                 :
          UART0SendString ( TMessage08 ) ;
          break ;
        default :
          UART0SendString ( TMessage09 ) ;
       }   ;
      break ;
    default :
      UART0SendString ( TMessage05 ) ;
  }   ;
  UART0Send ( 0x0D ) ;
  UART0Send ( 0x0A ) ;
}  

static UCHAR IPMessage10 [ ]          = "\r\nNaglowek IP:" ;
static UCHAR IPMessage11 [ ]          = "\r\nVERS=" ;
static UCHAR IPMessage12 [ ]          = " HLEN=" ;
static UCHAR IPMessage13 [ ]          = " TOS=" ;
static UCHAR IPMessage14 [ ]          = " TOTAL=" ;
static UCHAR IPMessage15 [ ]          = "\r\nIDENT=" ;
static UCHAR IPMessage16 [ ]          = " FLAGS=" ;
static UCHAR IPMessage17 [ ]          = " FRAGOFFS=" ;
static UCHAR IPMessage18 [ ]          = "\r\nTTL=" ;
static UCHAR IPMessage19 [ ]          = " PROT=" ;
static UCHAR IPMessage20 [ ]          = " HCRC=" ;
static UCHAR IPMessage21 [ ]          = "\r\nSRC=" ;
static UCHAR IPMessage22 [ ]          = "\r\nDST=" ;

void TraceIPHeader ( IPHeaderRecT * IPHeader )
{
   
  UART0SendString ( IPMessage10 ) ;
  UART0SendString ( IPMessage11 ) ;
  TraceUCHAR ( IPHeader -> Vers ) ;
  UART0SendString ( IPMessage12 ) ;
  TraceUCHAR ( IPHeader -> HLen ) ;
  UART0SendString ( IPMessage13 ) ;
  TraceUCHAR ( IPHeader -> ServiceType ) ;
  UART0SendString ( IPMessage14 ) ;
  TraceUSHORT ( IPHeader -> TotalLength ) ;
  UART0SendString ( IPMessage15 ) ;
  TraceUSHORT ( IPHeader -> Identification ) ;
  UART0SendString ( IPMessage16 ) ;
  TraceUCHAR ( IPHeader -> Flags ) ;
  UART0SendString ( IPMessage17 ) ;
  TraceUSHORT ( IPHeader -> FragmentOffs ) ;
  UART0SendString ( IPMessage18 ) ;
  TraceUCHAR ( IPHeader -> TTL ) ;
  UART0SendString ( IPMessage19 ) ;
  TraceUSHORT ( IPHeader -> Protocol ) ;
  UART0SendString ( IPMessage20 ) ;
  TraceUSHORT ( IPHeader -> HeaderChecksum ) ;
  UART0SendString ( IPMessage21 ) ;
  TraceIP ( IPHeader -> SourceIPAddress ) ;
  UART0SendString ( IPMessage22 ) ;
  TraceIP ( IPHeader -> DestinationIPAddress ) ;
  UART0Send ( 0x0D ) ;
  UART0Send ( 0x0A ) ;
}  


UCHAR Message01 [ ]              = "\r\nOdebrano ramke do MAC=" ;
UCHAR Message02 [ ]              = " od MAC=" ;
UCHAR Message03 [ ]              = ", jest to pakiet ARP\r\n" ;
UCHAR Message04 [ ]              = ", jest to pakiet IP\r\n" ;
UCHAR Message05 [ ]              = ", jest to pakiet ???\r\n" ;

void TraceETHHeader ( EtherPackedHeaderRecT * EtherPackedHeader )
{
   
  UART0SendString ( Message01 ) ;
  TraceMAC ( EtherPackedHeader -> DestinMACAddress ) ;
  UART0SendString ( Message02 ) ;
  TraceMAC ( EtherPackedHeader -> SourceMACAddress ) ;
  switch ( EtherPackedHeader -> LengthOrType )
  {
    case 0x0806    :
      UART0SendString ( Message03 ) ;
      break ;
    case 0x0800     :
      UART0SendString ( Message04 ) ;
      break ;
    default :
      UART0SendString ( Message05 ) ;
  }   ;
}  


void TraceMAC ( UCHAR * MACAddr )
{  
  UCHAR NumberStr [ 32 ] ;
  USHORT Loop ;
   
  for ( Loop = 0 ; Loop < 5 ; Loop ++ )
  {
    WordToHexStr ( NumberStr , 2 , '0' ,  ( USHORT ) ( * MACAddr ) ) ;
    MACAddr ++ ;
    UART0SendString ( NumberStr ) ;
    UART0Send ( '-' ) ;
  }   ;  
  WordToHexStr ( NumberStr , 2 , '0' ,  ( USHORT ) ( * MACAddr ) ) ;
  UART0SendString ( NumberStr ) ;
}  


void TraceIP ( ULONG IPAddress )
{
  UCHAR NumberStr [ 24 ] ;
   
  IPToString ( NumberStr , IPAddress ) ;
  UART0SendString ( NumberStr ) ;
}  


void TraceUCHAR ( UCHAR Data )
{
  UCHAR NumberStr [ 8 ] ;
   
  WordToHexStr ( NumberStr , 2 , '0' , ( USHORT ) Data ) ;
  UART0SendString ( NumberStr ) ;
}  
  

void TraceUSHORT ( USHORT Data )
{
  UCHAR NumberStr [ 8 ] ;
   
  WordToHexStr ( NumberStr , 4 , '0' , Data ) ;
  UART0SendString ( NumberStr ) ;
}  


void TraceUSHORTdec ( USHORT Data )
{
  UCHAR NumberStr [ 8 ] ;
   
  WordToStr ( NumberStr , 5 , '0' , Data ) ;
  UART0SendString ( NumberStr ) ;
}  


void TraceULONG ( ULONG Data )
{
  UCHAR NumberStr [ 12 ] ;
   
  LongToHexStr ( NumberStr , 8 , '0' , Data ) ;
  UART0SendString ( NumberStr ) ;
}  

